#include <complex>
#include <vector>

using namespace std;

void VoIP_Statistics();

int num_ues_in_outage;

double * throuhput_ue;

double     * avr_sinr;
int        * num_of_added;

double     * geometry;
double     * coupling_loss;
double     * RMS_delay_spread;
double     * circular_angle_spread_AOA;
double     * circular_angle_spread_AOD;



/*===================================================================
FUNCTION: STASTICS()

AUTHOR: Noh, jung-hoon

DESCRIPTION: Structure for getting cdf , pdf histograms
PDF will be added

NOTES: 2009-08-12

===================================================================*/
struct STASTICS
{
	double * samples;
	int         size;
	char * name;

	vector < double > cdf;
	// setting up basic parameter 

	void setup(double * _samples, int _size, char * _name)
	{
		samples = _samples;
		size = _size;
		name = _name;
		cdf.clear();
	}
	
	// get cdf ( percetile type 0 ~100% )
	void get_cdf(void)
	{
		
		sort(samples, samples + size); //  -> ū  , size = num_drop * num_MS
		
		cdf.push_back(samples[0]);

		for (int percentile = 1; percentile < 101; percentile++)
		{
			//int idx = (int)itpp::round(size*percentile*0.01);
			int idx = (int)((size-1)*percentile*0.01);
			cdf.push_back(samples[idx]);
		}
		
	}

	// Print Out CDF
	void print_cdf(void)
	{
		/*
		ofstream print_out_cdf;
		char cdf_path[50];
		strcpy(cdf_path, path);
		strcat(cdf_path, "/");
		strcat(cdf_path, name);
		strcat(cdf_path, "_cdf.dat");

		print_out_cdf.open(cdf_path, ios::out);

		for (int percentile = 0; percentile < 101; percentile++)
		{
			print_out_cdf << percentile << "\t" << cdf[percentile] << endl;
		}
		print_out_cdf.close();

		*/

		ofstream print_out_cdf;
		char cdf_path[100];
		strcpy(cdf_path, name);
		strcat(cdf_path, "_cdf.dat");

		print_out_cdf.open(cdf_path, ios::out);

		for (int percentile = 0; percentile < 101; percentile++)
		{
			print_out_cdf << percentile << "\t" << cdf[percentile] << endl;
			
			//cout << cdf[percentile] << endl;
		}
		print_out_cdf.close();

	}
	

};






