#include "common.h"
#include "const.h"
#include <iostream>
#include <fstream>
#include <cmath>
#include <time.h>

using namespace std;

#include <cstring>
#include <cstdlib>

double Get_distance(LOCATION , LOCATION );

/*
/*===================================================================
FUNCTION: UE::Channel_Update_MIMO( void )



===================================================================*/
void MS::Channel_Update_MIMO(int ms_idx)
{
	_self_idx = ms_idx;

	/*===================================================================
	FUNCTION : Declare_Ch_matrix()
	OUTPUT   : H_m, HI_m(interference channel)
	===================================================================*/
	if (CH_CAL == 1)
	{
		Declare_ch_matrix();
	}
	/*===================================================================
	FUNCTION : Fourier_Transform_of_Channel(_self_idx)
	OUTPUT   : H_m, HI_m(interference channel)
	===================================================================*/
	Fourier_Transform_of_Channel(_self_idx);

	/*===================================================================
	FUNCTION : Quantization_of_Ch()
	INPUT    : H_m
	OUTPUT   : PMI(cw_idx )
	===================================================================*/
	Quantization_of_Ch();

	/*===================================================================
	FUNCTION : CQI_Update()
	INPUT    : H_m, UE_PATH_LOSS, UE_ICI
	OUTPUT   : CQI(esinr)
	===================================================================*/
	CQI_Update();


	

}

void MS::Quantization_of_Ch(void)
{
	if (CH_CAL == 1) //// run time calc
	{
		for (int rbs_idx = 0; rbs_idx < num_rbs_in_1ms; rbs_idx++)
		{
			
			if (false ) //(NUM_TX == 4)   /// PMI Decision
			{
				Matrix4cd Ohm;

				double min = 500;

				for (int cw_idx = 0; cw_idx < 16; cw_idx++)
				{

					Ohm = WW[cw_idx] * (H_m[rbs_idx].adjoint() * H_m[rbs_idx]) * WW[cw_idx].adjoint(); //Ohm = W HH H WH // 4x4 matrix

					Matrix4cd UppOhm;
					Matrix4cd LowOhm;

					UppOhm = Ohm.triangularView<StrictlyUpper>(); //diagonal   triangle matrix 
					LowOhm = Ohm.triangularView<StrictlyLower>(); //diagonal  Ʒ triangle matrix 



					double temp = UppOhm.norm() + LowOhm.norm(); // minimizes off diagonal entries of Ohm

					if (temp < min)
					{
						min = temp;
						PMI[rbs_idx][t%cqi_history_length] = cw_idx;
					}
				}
			}
			else if (false)  ////  ڵ PMI  
			{
				JacobiSVD <MatrixXcd> svd(H_m[rbs_idx], ComputeFullU | ComputeFullV);    ////// U = 2x2, V = 4x4

				/*
				cout << "Its singular values are:" << endl << svd.singularValues() << endl;
				cout << "Its left singular vectors are the columns of the thin U matrix:" << endl << svd.matrixU() << endl;
				cout << "Its right singular vectors are the columns of the thin V matrix:" << endl << svd.matrixV() << endl;

				getchar();
				*/

				MatrixXcd H_eq;

				H_eq = (svd.matrixV().col(0)).adjoint();  ///////// 1x4 vector

				//cout << "H_eq = " << H_eq << endl;

				double max = -500;

				for (int cw_idx = 0; cw_idx < 64; cw_idx++)
				{
					double temp = (H_eq * code_word[cw_idx].conjugate()).norm();

					if (temp > max)
					{
						max = temp;
						PMI[rbs_idx][t%cqi_history_length] = cw_idx;
					}
				}

				//cout << "Precalc_PMI = " << PMI_precalc[_time_idx][los_idx][indoor_idx][v][rbs_idx] << endl;
				//getchar();

			}

			else /// Random PMI 
			{
				PMI[rbs_idx][t%cqi_history_length] = rand() % 16;
			}
		}
	}
}





void MS::CQI_Update(void)
{

	if (CH_CAL == 1)  //// run-time calculate
	{
		if (NUM_TX != 4)   // No Use PMI
		{
			for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
			{
				double Received_SINR = 0.;
				double sum_of_ch_coef = 0.;
				complex<double> s(1, 2);
				for (int r_idx = 0; r_idx < NUM_RX; r_idx++) // Received    Channel
				{
					for (int t_idx = 0; t_idx < NUM_TX; t_idx++) // Transmitted Channel
					{
						sum_of_ch_coef += pow(abs(H_m[rb_idx](r_idx, t_idx)), 2.);
					}
				}

				double geometry = link[_self_idx].str_signal - link[_self_idx].interference; // ̰Ŵ dB // ̰ (link[_self_idx].UE_PATH_LOSS / link[_self_idx].UE_ICI) ̰Ŷ  (linear)

				double linear_signal = dBm2linear(link[_self_idx].str_signal);
				double linear_interference = dBm2linear(link[_self_idx].interference);

				linear_interference = linear_interference + noise;
				

				CQI[rb_idx][t % cqi_history_length] = sum_of_ch_coef * (linear_signal / linear_interference); /// 
			}
		}
		else   //// Use PMI
		{
			for (int rbs_idx = 0; rbs_idx < num_rbs_in_1ms; rbs_idx++)
			{

				//cmat M, A, B, C, w, u;

				MatrixXcd A;
				MatrixXcd B;
				VectorXcd w;
				Matrix2cd eye = Matrix2cd::Identity();

				double sinr_estimate;

				double geometry = link[_self_idx].str_signal - link[_self_idx].interference; // ̰Ŵ dB // ̰ (link[_self_idx].UE_PATH_LOSS / link[_self_idx].UE_ICI) ̰Ŷ  (linear)

				double linear_signal = dBm2linear(link[_self_idx].str_signal);
				double linear_interference = dBm2linear(link[_self_idx].interference);

				linear_interference = linear_interference + noise;

				
				w = code_word[PMI[rbs_idx][t%cqi_history_length]].conjugate();   // 4x1 vector
				A = linear_signal * H_m[rbs_idx] * w;   // 2x4 4x1
				B = linear_interference * eye;   /// 2x2 indentity
				
				// A norm  vector norm ,  ؼ ؼ Ʈ
				// B norm  matrix 2-norm, identity ׳ linear interference̶  


				///sinr_estimate = A.norm() / B.norm();
				sinr_estimate = A.norm() / linear_interference;

				//cout << sinr_estimate << endl;
				//  sinr_estimate = dB2linear(linear2dB( sinr_estimate ) + CQI_offset);


				CQI[rbs_idx][abs(t) % cqi_history_length] = sinr_estimate;
			}
		}
	}
}

void MS::Fourier_Transform_of_Channel(int ms_idx)
{
	if (CH_CAL == 1)   //// runtime calc
	{
		int self_idx = ms_idx;
		int A = 0;

		if (TYPE == 11)
		{
			A = link[self_idx]._sector_in_control;
		}
		else
		{
			A = (int)(link[self_idx].adj_sector[0] / 3);
		}

		for (int r_idx = 0; r_idx < NUM_RX; r_idx++) // Received    Channel
		{
			for (int t_idx = 0; t_idx < NUM_TX; t_idx++) // Transmitted Channel
			{
				int pointer = (int(DFT_SIZE) - (num_rbs_in_1ms*num_freq_per_rbs)) / 2;
				double sum_for_normal = 0;
				for (int rbs_idx = 0; rbs_idx < num_rbs_in_1ms; rbs_idx++) // Subcarrier idx
				{
					int freq_idx = (pointer + (num_freq_per_rbs / 2) + (rbs_idx*num_freq_per_rbs)) * 15000;
					for (int path_idx = 0; path_idx < channel[A][self_idx].num_path; path_idx++)
					{
						complex <double> dft_exp(0.0, -2 * pi*freq_idx*(channel[A][self_idx].delay[path_idx]));
						H_m[rbs_idx](r_idx, t_idx) += channel[A][self_idx].CHIR[t_idx][r_idx][path_idx] * exp(dft_exp);

					}
					sum_for_normal += pow(abs(H_m[rbs_idx](r_idx, t_idx)), 2.);
				}

				sum_for_normal = sum_for_normal / (double)num_rbs_in_1ms;

				for (int rbs_idx = 0; rbs_idx < num_rbs_in_1ms; rbs_idx++) // Subcarrier idx
				{
					H_m[rbs_idx](r_idx, t_idx) = H_m[rbs_idx](r_idx, t_idx) / sqrt(sum_for_normal);
				}
			}
		}
	}
}









void MS::Declare_ch_matrix(void)
{


	if (H_m == NULL)
	{
		H_m = new MatrixXcd[num_rbs_in_1ms];
	}



	for (int freq_idx = 0; freq_idx < num_rbs_in_1ms; freq_idx++)
	{
		MatrixXcd temp(NUM_RX, NUM_TX);

		for (int r_idx = 0; r_idx < NUM_RX; r_idx++)
		{
			for (int t_idx = 0; t_idx < NUM_TX; t_idx++)
			{
				temp(r_idx, t_idx) = 0.;
			}
		}
		H_m[freq_idx] = temp;
	}

	//// H_m[num_rbs_in_1ms](NUM_RX,NUM_TX)


	if (HI_m == NULL)
	{
		HI_m = new MatrixXcd *[num_compute_coef - 1];
		for (int i = 0; i < num_compute_coef - 1; i++)
		{
			HI_m[i] = new MatrixXcd[num_rbs_in_1ms];
		}

	}


	for (int i = 0; i < num_compute_coef - 1; i++)
	{
		for (int freq_idx = 0; freq_idx < num_rbs_in_1ms; freq_idx++)
		{
			MatrixXcd temp(NUM_RX, NUM_TX);

			for (int r_idx = 0; r_idx < NUM_RX; r_idx++)
			{
				for (int t_idx = 0; t_idx < NUM_TX; t_idx++)
				{
					temp(r_idx, t_idx) = 0.;
				}
			}
			HI_m[i][freq_idx] = temp;
		}
	}

	//// HI_m[num_compute_coef - 1][num_rbs_in_1ms](NUM_RX,NUM_TX)

	//cout << "HI_m = " << endl << HI_m[0][0] << endl;

	//cout << "HI_m = " << endl << HI_m[0][1] << endl;

}


/*
double Get_distance(LOCATION a, LOCATION b)
{
	return sqrt((a.x - b.x)*(a.x - b.x) + (a.y - b.y)*(a.y - b.y));
}
*/

////////////////////////////////////////////////// PMI  ̸ϴ° ߸ ڵ ///////////////////////////////////////////////////////////////////////////
/*
void MS::Precalculate_PMI(int _ms_idx, int _time)
{
	_self_idx = _ms_idx;
	int time_idx = _time;

	//clock_t begin, end;
	//begin = clock();

	Declare_ch_matrix_precalc();


	Fourier_Transform_of_Channel_precalc(_self_idx, time_idx);
	//begin = clock();

	Quantization_of_Ch_precalc(time_idx);
	//begin = clock();

	//CQI_Update();
	//end = clock();
	//

	//cout << "TIME = " << endl << (double)(end - begin) / CLOCKS_PER_SEC << endl;


}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MS::Declare_ch_matrix_precalc(void)
{


MatrixXcd *Hm[20000][2][2];

for (int time_idx = 0; time_idx < precalculate_time; time_idx++)
{
for (int los_idx = 0; los_idx < 2; los_idx++)
{
for (int indoor_idx = 0; indoor_idx < 2; indoor_idx++)
{
Hm[time_idx][los_idx][indoor_idx] = new MatrixXcd[num_rbs_in_1ms];
}
}
}






for (int freq_idx = 0; freq_idx < num_rbs_in_1ms; freq_idx++)
{
MatrixXcd temp(NUM_RX, NUM_TX);

for (int r_idx = 0; r_idx < NUM_RX; r_idx++)
{
for (int t_idx = 0; t_idx < NUM_TX; t_idx++)
{
temp(r_idx, t_idx) = 0.;
}
}
H_m[freq_idx] = temp;
}

//// H_m[num_rbs_in_1ms](NUM_RX,NUM_TX)


if (HI_m == NULL)
{
HI_m = new MatrixXcd *[num_compute_coef - 1];
for (int i = 0; i < num_compute_coef - 1; i++)
{
HI_m[i] = new MatrixXcd[num_rbs_in_1ms];
}

}


for (int i = 0; i < num_compute_coef - 1; i++)
{
for (int freq_idx = 0; freq_idx < num_rbs_in_1ms; freq_idx++)
{
MatrixXcd temp(NUM_RX, NUM_TX);

for (int r_idx = 0; r_idx < NUM_RX; r_idx++)
{
for (int t_idx = 0; t_idx < NUM_TX; t_idx++)
{
temp(r_idx, t_idx) = 0.;
}
}
HI_m[i][freq_idx] = temp;
}
}

//// HI_m[num_compute_coef - 1][num_rbs_in_1ms](NUM_RX,NUM_TX)

//cout << "HI_m = " << endl << HI_m[0][0] << endl;

//cout << "HI_m = " << endl << HI_m[0][1] << endl;

}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MS::Fourier_Transform_of_Channel_precalc(int ms_idx, int _time)
{

int self_idx = ms_idx;
int A = 0;

if (TYPE == 1)
{
A = link[self_idx]._sector_in_control;
}
else
{
A = link[self_idx].adj_sector[0] / 3;
}




for (int r_idx = 0; r_idx < NUM_RX; r_idx++) // Received    Channel
{
for (int t_idx = 0; t_idx < NUM_TX; t_idx++) // Transmitted Channel
{
int pointer = (int(DFT_SIZE) - (num_rbs_in_1ms*num_freq_per_rbs)) / 2;
double sum_for_normal = 0;

for (int rbs_idx = 0; rbs_idx < num_rbs_in_1ms; rbs_idx++) // Subcarrier idx
{
int freq_idx = (pointer + (num_freq_per_rbs / 2) + (rbs_idx*num_freq_per_rbs)) * 15000;

for (int path_idx = 0; path_idx < channel[A][self_idx].num_path; path_idx++)
{
/// num_path ׳ MAX num cluster
/// delay LOS / NLOS ؼ ϵ ϰ channel[0][0].delay_LOS[path_idx] ̷

complex <double> dft_exp(0.0, -2 * pi*freq_idx*(channel[A][self_idx].delay[path_idx]));




H_m[rbs_idx](r_idx, t_idx) += CHIR_precalc[_time][0][0][0][t_idx][r_idx][path_idx] * exp(dft_exp);

}

sum_for_normal += pow(abs(H_m[rbs_idx](r_idx, t_idx)), 2.);
}

sum_for_normal = sum_for_normal / (double)num_rbs_in_1ms;

for (int rbs_idx = 0; rbs_idx < num_rbs_in_1ms; rbs_idx++) // Subcarrier idx
{
H_m[rbs_idx](r_idx, t_idx) = H_m[rbs_idx](r_idx, t_idx) / sqrt(sum_for_normal);
}
}
}







}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void MS::Quantization_of_Ch_precalc(int _time)
{

for (int rbs_idx = 0; rbs_idx < num_rbs_in_1ms; rbs_idx++)
{

Matrix4cd Ohm;

double min = 500;

for (int cw_idx = 0; cw_idx < 16; cw_idx++)
{

Ohm = WW[cw_idx] * (H_m[rbs_idx].adjoint() * H_m[rbs_idx]) * WW[cw_idx].adjoint(); //Ohm = W HH H WH // 4x4 matrix

Matrix4cd UppOhm;
Matrix4cd LowOhm;

UppOhm = Ohm.triangularView<StrictlyUpper>(); //diagonal   triangle matrix
LowOhm = Ohm.triangularView<StrictlyLower>(); //diagonal  Ʒ triangle matrix

double temp = UppOhm.norm() + LowOhm.norm(); // minimizes off diagonal entries of Ohm

if (temp < min)
{
min = temp;
PMI[rbs_idx][_time % cqi_history_length] = cw_idx;
}
}


//PMI[rbs_idx][t%cqi_history_length] = rand() % 16;

//cout << "PMI = " << PMI[rbs_idx][t%cqi_history_length] << endl;

}

}
*/