
/*
////////////////////////
5G DownLink System Level Simulator
////////////////////////
*/

#include <stdio.h>
#include <time.h>
#include "common.h"

void Set_simul_param(int argc, char *argv[]);
void Set_Parameter(int scenario);
void InitializeSystem();
void Set_fastfading_param();
void Allocate_memory(void);
void Initialdrop();
void Initialize_CHANNEL();
void Print_Location(int drop_idx);
void Parameter_initialization();
void Generate_SSP();
void Compute_Channel_Coef();
void ClearMAPs2StartADrop();
void Generate_LSP(void);
void Link_configuration();
void Get_CouplingLoss();
void Coupling_Loss_CDF(void);
void Geometry_CDF(void);
void Delete_memory(void);
void loading(void);


int main(int argc, char *argv[])
{
	CH_CAL = 1;                  //// for runtime calculate
	Scheduling_Type = 0;         //// roundrobin scheduling

	Set_simul_param(argc, argv);
	Set_Parameter(scenario);
	InitializeSystem(); 
	Set_fastfading_param();
	Allocate_memory();

	for (drop_idx = 0; drop_idx < num_drop; drop_idx++)
	{
		cout << "Drop # " << drop_idx << "/" << num_drop << " ing... " << endl;
		cout << "  " << endl;

		Initialdrop();
		cout << "initialdrop DONE" << endl;
		cout << "  " << endl;

		Initialize_CHANNEL();
		Generate_LSP();
		Link_configuration();
		ClearMAPs2StartADrop();

		Get_CouplingLoss();
		Print_Location(drop_idx);

		Parameter_initialization(); 
		cout << "Parameter initialization done " << endl;
		cout << "  " << endl;


		for (t = 0; t < run_times + SCHEDULE_DELAY; t++)
		{
			Generate_SSP();
			Compute_Channel_Coef();

			if (t > SCHEDULE_DELAY)  // SCHEDULE_DELAY = 5
			{
				for (int idx = 0; idx < num_SECTORS; idx++) ///NUM_SECTORS = 57 
				{
					sector[idx].Scheduling(Scheduling_Type); 

				}
				cout << " Scheduling done" << endl;
			}
			cout << " Channel Update START " << endl;

			for (int idx = 0; idx < num_MS; idx++)
			{
				ms[idx].Channel_Update_MIMO(idx); //PMI Ѵ, PMIʰ Ǿ Ƿ PMIʿ .

			}
			cout << " Channel Update DONE " << endl;

			if (t > SCHEDULE_DELAY)
			{
				for (int idx = 0; idx < num_MS; idx++)
				{
					//ms[idx].Receive_DL(idx);
				}
				cout << " Receive_DL... done" << endl;
			}

			//loading();

		}




	}

	Geometry_CDF();
	cout << " check Geometry CDF " << endl;
	Coupling_Loss_CDF();
	cout << " check Coupling Loss CDF " << endl;

	Delete_memory();

	return 0;
}


















/*
void make_directory(void)
{
	char forder_name[50];
	for (int idx = 0; idx < 2 * sizeof(file_name); idx++)
	{
		if (file_name[idx] == '.')
		{
			if (file_name[idx + 1] == '/')
			{
				int k = 1;
				while (file_name[idx + 1 + k] != '/')
				{
					forder_name[k - 1] = file_name[idx + 1 + k];
					k++;
				}
				forder_name[k - 1] = '\0';
			}
		}
	}
	mkdir(forder_name, 0777);
	path[0] = '.';   path[1] = '/';   path[2] = '\0';
	strcat(path, forder_name);
}
*/


////////////////////////////////////////////////////////
/// Eigen Test Code 
////////////////////////////////////////////////////////
/*

#include <iostream>
#include <Eigen/Dense>
#define PI 3.14159265359

using namespace Eigen;
using namespace std;

int main()
{
	MatrixXd m1 = MatrixXd(8, 8);
	MatrixXd m2, m3;

	Matrix2cd mm1;


	//8*8 m1  ־ݴϴ.
	double* alpha = new double[8];
	for (int i = 0; i < 8; i++) {
		if (i == 0)
			alpha[i] = 1. / (2.*sqrt(2));
		else {
			alpha[i] = 0.5;
		}
	}

	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 8; j++) {
			m1(i, j) = alpha[i] * cos((PI*(2.*j + 1)*i) / 16);
		}
	}
	delete alpha;

	m2 = m1.transpose();//m2 m1 transpose  ־ݴϴ.
	m3 = m1*m2;//m3 m1 m2   ־ݴϴ.
	cout << "m1" << endl << m1 << endl << "m2" << endl << m2 << endl << "m3" << endl << m3 << endl;//!


	mm1(0, 0) = complex <double>(1, -1);

	cout << "mm1 = " << endl << mm1 << endl;

	return 0;

}


*/


///////////////////////////////////////////////////////
//
//mat: Basic matrix type containing double
//
//cmat: Matrix type containing complex<double>
//
//imat: Matrix type containing int 
//bmat: Matrix type containing bin
//smat : Matrix type containing short
//
//
//
////////////////////////////////////////////////////////////
/////////////////////// Eigen Library TEST Code ////////////////////////////////
/*
#include <iostream>
#include <Eigen/Dense>
using Eigen::MatrixXd;
int main()
{
MatrixXd m(2, 2);
m(0, 0) = 3;
m(1, 0) = 2.5;
m(0, 1) = -1;
m(1, 1) = m(1, 0) + m(0, 1);
std::cout << m << std::endl;
}
*/
/////////////////////// Eigen Library TEST Code ////////////////////////////////